import {
  transform
} from "./chunk-ZOIZIABO.mjs";
import {
  finalizeContext,
  getTransformResult,
  initContext
} from "./chunk-BW32ATX4.mjs";

// src/unplugin.ts
import { createUnplugin } from "unplugin";
import { createFilter } from "@rollup/pluginutils";
function resolveOption(options) {
  return {
    include: options.include || [/\.vue$/],
    exclude: options.exclude || void 0
  };
}
var unplugin_default = createUnplugin((options = {}) => {
  const opt = resolveOption(options);
  const filter = createFilter(opt.include, opt.exclude);
  const name = "unplugin-vue-define-options";
  return {
    name,
    enforce: "pre",
    transformInclude(id) {
      return filter(id);
    },
    transform(code, id) {
      try {
        const { ctx, getMagicString } = initContext(code, id);
        transform(ctx);
        finalizeContext(ctx);
        return getTransformResult(getMagicString(), id);
      } catch (err) {
        this.error(`${name} ${err}`);
      }
    }
  };
});

export {
  unplugin_default
};
